Index: serefpolicy-contrib-20140730/xen.te
===================================================================
--- serefpolicy-contrib-20140730.orig/xen.te
+++ serefpolicy-contrib-20140730/xen.te
@@ -1,42 +1,34 @@
-policy_module(xen, 1.13.1)
+policy_module(xen, 1.13.0)
 
 ########################################
 #
 # Declarations
 #
+attribute xm_transition_domain;
 
 ## <desc>
-##	<p>
-##	Determine whether xend can
-##	run blktapctrl and tapdisk.
+## <p>
+## Allow xend to run blktapctrl/tapdisk.
+## Not required if using dedicated logical volumes for disk images.
 ## </p>
 ## </desc>
-gen_tunable(xend_run_blktap, false)
+gen_tunable(xend_run_blktap, true)
 
 ## <desc>
-##	<p>
-##	Determine whether xen can
-##	use fusefs file systems.
-##	</p>
+## <p>
+## Allow xend to run qemu-dm.
+## Not required if using paravirt and no vfb.
+## </p>
 ## </desc>
-gen_tunable(xen_use_fusefs, false)
+gen_tunable(xend_run_qemu, true)
 
 ## <desc>
-##	<p>
-##	Determine whether xen can
-##	use nfs file systems.
-##	</p>
+## <p>
+## Allow xen to manage nfs files
+## </p>
 ## </desc>
 gen_tunable(xen_use_nfs, false)
 
-## <desc>
-##	<p>
-##	Determine whether xen can
-##	use samba file systems.
-##	</p>
-## </desc>
-gen_tunable(xen_use_samba, false)
-
 type blktap_t;
 type blktap_exec_t;
 domain_type(blktap_t)
@@ -50,41 +42,55 @@ type evtchnd_t;
 type evtchnd_exec_t;
 init_daemon_domain(evtchnd_t, evtchnd_exec_t)
 
+# log files
 type evtchnd_var_log_t;
 logging_log_file(evtchnd_var_log_t)
 
+# pid files
 type evtchnd_var_run_t;
 files_pid_file(evtchnd_var_run_t)
 
+type qemu_dm_t;
+type qemu_dm_exec_t;
+domain_type(qemu_dm_t)
+domain_entry_file(qemu_dm_t, qemu_dm_exec_t)
+role system_r types qemu_dm_t;
+
+# console ptys
 type xen_devpts_t;
 term_pty(xen_devpts_t)
 files_type(xen_devpts_t)
 
+# Xen Image files
 type xen_image_t; # customizable
 files_type(xen_image_t)
+# xen_image_t can be assigned to blk devices
 dev_node(xen_image_t)
-
-optional_policy(`
-	virt_image(xen_image_t)
-')
+virt_image(xen_image_t)
 
 type xenctl_t;
 files_type(xenctl_t)
 
 type xend_t;
 type xend_exec_t;
+domain_type(xend_t)
 init_daemon_domain(xend_t, xend_exec_t)
 
+# tmp files
 type xend_tmp_t;
 files_tmp_file(xend_tmp_t)
 
+# var/lib files
 type xend_var_lib_t;
 files_type(xend_var_lib_t)
+# for mounting an NFS store
 files_mountpoint(xend_var_lib_t)
 
+# log files
 type xend_var_log_t;
 logging_log_file(xend_var_log_t)
 
+# pid files
 type xend_var_run_t;
 files_pid_file(xend_var_run_t)
 files_mountpoint(xend_var_run_t)
@@ -96,51 +102,50 @@ init_daemon_domain(xenstored_t, xenstore
 type xenstored_tmp_t;
 files_tmp_file(xenstored_tmp_t)
 
+# var/lib files
 type xenstored_var_lib_t;
 files_type(xenstored_var_lib_t)
 files_mountpoint(xenstored_var_lib_t)
 
+# log files
 type xenstored_var_log_t;
 logging_log_file(xenstored_var_log_t)
 
+# pid files
 type xenstored_var_run_t;
 files_pid_file(xenstored_var_run_t)
-init_daemon_pid_file(xenstored_var_run_t, dir, "xenstored")
 
 type xenconsoled_t;
 type xenconsoled_exec_t;
 init_daemon_domain(xenconsoled_t, xenconsoled_exec_t)
 
+# pid files
 type xenconsoled_var_run_t;
 files_pid_file(xenconsoled_var_run_t)
 
-type xm_t;
-type xm_exec_t;
-init_system_domain(xm_t, xm_exec_t)
-
 ########################################
 #
 # blktap local policy
 #
-
+# Do we need to allow execution of blktap?
 tunable_policy(`xend_run_blktap',`
+        # If yes, transition to its own domain.
 	domtrans_pattern(xend_t, blktap_exec_t, blktap_t)
 
-	allow blktap_t self:fifo_file { read write };
+',`
+        # If no, then silently refuse to run it.
+	dontaudit xend_t blktap_exec_t:file { execute execute_no_trans };
+')
 
-	dev_read_sysfs(blktap_t)
-	dev_rw_xen(blktap_t)
+allow blktap_t self:fifo_file { read write };
 
-	files_read_etc_files(blktap_t)
+dev_read_sysfs(blktap_t)
+dev_rw_xen(blktap_t)
 
-	logging_send_syslog_msg(blktap_t)
 
-	miscfiles_read_localization(blktap_t)
+logging_send_syslog_msg(blktap_t)
 
-	xen_stream_connect_xenstore(blktap_t)
-',`
-	dontaudit xend_t blktap_exec_t:file { execute execute_no_trans };
-')
+xen_stream_connect_xenstore(blktap_t)
 
 #######################################
 #
@@ -148,9 +153,7 @@ tunable_policy(`xend_run_blktap',`
 #
 
 manage_dirs_pattern(evtchnd_t, evtchnd_var_log_t, evtchnd_var_log_t)
-append_files_pattern(evtchnd_t, evtchnd_var_log_t, evtchnd_var_log_t)
-create_files_pattern(evtchnd_t, evtchnd_var_log_t, evtchnd_var_log_t)
-setattr_files_pattern(evtchnd_t, evtchnd_var_log_t, evtchnd_var_log_t)
+manage_files_pattern(evtchnd_t, evtchnd_var_log_t, evtchnd_var_log_t)
 logging_log_filetrans(evtchnd_t, evtchnd_var_log_t, { file dir })
 
 manage_dirs_pattern(evtchnd_t, evtchnd_var_run_t, evtchnd_var_run_t)
@@ -160,28 +163,68 @@ files_pid_filetrans(evtchnd_t, evtchnd_v
 
 ########################################
 #
+# qemu-dm local policy
+#
+
+# TODO: This part of policy should be removed
+#       qemu-dm should run in xend_t domain
+
+# Do we need to allow execution of qemu-dm?
+tunable_policy(`xend_run_qemu',`
+	allow qemu_dm_t self:capability sys_resource;
+	allow qemu_dm_t self:process setrlimit;
+	allow qemu_dm_t self:fifo_file { read write };
+	allow qemu_dm_t self:tcp_socket create_stream_socket_perms;
+
+	# If yes, transition to its own domain.
+	domtrans_pattern(xend_t, qemu_dm_exec_t, qemu_dm_t)
+
+	append_files_pattern(qemu_dm_t, xend_var_log_t, xend_var_log_t)
+
+	rw_fifo_files_pattern(qemu_dm_t, xend_var_run_t, xend_var_run_t)
+
+	corenet_tcp_bind_generic_node(qemu_dm_t)
+	corenet_tcp_bind_vnc_port(qemu_dm_t)
+
+	dev_rw_xen(qemu_dm_t)
+
+
+	fs_manage_xenfs_dirs(qemu_dm_t)
+	fs_manage_xenfs_files(qemu_dm_t)
+
+
+	xen_stream_connect_xenstore(qemu_dm_t)
+',`
+        # If no, then silently refuse to run it.
+	dontaudit xend_t qemu_dm_exec_t:file { execute execute_no_trans };
+')
+
+########################################
+#
 # xend local policy
 #
 
-allow xend_t self:capability { dac_override ipc_lock net_admin setuid sys_admin sys_nice sys_tty_config net_raw sys_resource sys_rawio };
-dontaudit xend_t self:capability { sys_ptrace };
-allow xend_t self:process { setrlimit signal sigkill };
-dontaudit xend_t self:process ptrace;
+allow xend_t self:capability { dac_override ipc_lock net_admin setuid sys_admin sys_nice sys_tty_config net_raw sys_rawio };
+allow xend_t self:process { signal sigkill };
+
+# needed by qemu_dm
+allow xend_t self:capability sys_resource;
+allow xend_t self:process setrlimit;
+
+# internal communication is often done using fifo and unix sockets.
 allow xend_t self:fifo_file rw_fifo_file_perms;
-allow xend_t self:unix_stream_socket { accept listen };
-allow xend_t self:tcp_socket { accept listen };
+allow xend_t self:unix_stream_socket create_stream_socket_perms;
+allow xend_t self:unix_dgram_socket create_socket_perms;
+allow xend_t self:netlink_route_socket r_netlink_socket_perms;
+allow xend_t self:tcp_socket create_stream_socket_perms;
 allow xend_t self:packet_socket create_socket_perms;
 allow xend_t self:tun_socket create_socket_perms;
 
 allow xend_t xen_image_t:dir list_dir_perms;
 manage_dirs_pattern(xend_t, xen_image_t, xen_image_t)
-manage_fifo_files_pattern(xend_t, xen_image_t, xen_image_t)
 manage_files_pattern(xend_t, xen_image_t, xen_image_t)
 read_lnk_files_pattern(xend_t, xen_image_t, xen_image_t)
-read_sock_files_pattern(xend_t, xen_image_t, xen_image_t)
-rw_chr_files_pattern(xend_t, xen_image_t, xen_image_t)
 rw_blk_files_pattern(xend_t, xen_image_t, xen_image_t)
-fs_hugetlbfs_filetrans(xend_t, xen_image_t, file)
 
 allow xend_t xenctl_t:fifo_file manage_fifo_file_perms;
 dev_filetrans(xend_t, xenctl_t, fifo_file)
@@ -190,33 +233,37 @@ manage_files_pattern(xend_t, xend_tmp_t,
 manage_dirs_pattern(xend_t, xend_tmp_t, xend_tmp_t)
 files_tmp_filetrans(xend_t, xend_tmp_t, { file dir })
 
+# pid file
 manage_dirs_pattern(xend_t, xend_var_run_t, xend_var_run_t)
 manage_files_pattern(xend_t, xend_var_run_t, xend_var_run_t)
 manage_sock_files_pattern(xend_t, xend_var_run_t, xend_var_run_t)
 manage_fifo_files_pattern(xend_t, xend_var_run_t, xend_var_run_t)
 files_pid_filetrans(xend_t, xend_var_run_t, { file sock_file fifo_file dir })
 
+# log files
 manage_dirs_pattern(xend_t, xend_var_log_t, xend_var_log_t)
-append_files_pattern(xend_t, xend_var_log_t, xend_var_log_t)
-create_files_pattern(xend_t, xend_var_log_t, xend_var_log_t)
-setattr_files_pattern(xend_t, xend_var_log_t, xend_var_log_t)
+manage_files_pattern(xend_t, xend_var_log_t, xend_var_log_t)
 manage_sock_files_pattern(xend_t, xend_var_log_t, xend_var_log_t)
 logging_log_filetrans(xend_t, xend_var_log_t, { sock_file file dir })
 
+# var/lib files for xend
 manage_dirs_pattern(xend_t, xend_var_lib_t, xend_var_lib_t)
 manage_files_pattern(xend_t, xend_var_lib_t, xend_var_lib_t)
 manage_sock_files_pattern(xend_t, xend_var_lib_t, xend_var_lib_t)
 manage_fifo_files_pattern(xend_t, xend_var_lib_t, xend_var_lib_t)
 files_var_lib_filetrans(xend_t, xend_var_lib_t, { file dir })
 
+# transition to store
+domtrans_pattern(xend_t, xenstored_exec_t, xenstored_t)
+
+# manage xenstored pid file
 manage_files_pattern(xend_t, xenstored_var_run_t, xenstored_var_run_t)
 
-allow xend_t xenstored_var_lib_t:dir list_dir_perms;
+# mount tmpfs on /var/lib/xenstored
+allow xend_t xenstored_var_lib_t:dir read;
 
+# transition to console
 domtrans_pattern(xend_t, xenconsoled_exec_t, xenconsoled_t)
-domtrans_pattern(xend_t, xenstored_exec_t, xenstored_t)
-
-xen_stream_connect_xenstore(xend_t)
 
 kernel_read_kernel_sysctls(xend_t)
 kernel_read_system_state(xend_t)
@@ -224,61 +271,44 @@ kernel_write_xen_state(xend_t)
 kernel_read_xen_state(xend_t)
 kernel_rw_net_sysctls(xend_t)
 kernel_read_network_state(xend_t)
+kernel_request_load_module(xend_t)
 
 corecmd_exec_bin(xend_t)
 corecmd_exec_shell(xend_t)
 
-corenet_all_recvfrom_unlabeled(xend_t)
 corenet_all_recvfrom_netlabel(xend_t)
 corenet_tcp_sendrecv_generic_if(xend_t)
 corenet_tcp_sendrecv_generic_node(xend_t)
 corenet_tcp_sendrecv_all_ports(xend_t)
 corenet_tcp_bind_generic_node(xend_t)
-
-corenet_sendrecv_xen_server_packets(xend_t)
 corenet_tcp_bind_xen_port(xend_t)
-
-corenet_sendrecv_soundd_server_packets(xend_t)
 corenet_tcp_bind_soundd_port(xend_t)
-
-corenet_sendrecv_generic_server_packets(xend_t)
 corenet_tcp_bind_generic_port(xend_t)
-
-corenet_sendrecv_vnc_server_packets(xend_t)
 corenet_tcp_bind_vnc_port(xend_t)
-
-corenet_sendrecv_xserver_client_packets(xend_t)
 corenet_tcp_connect_xserver_port(xend_t)
-
-corenet_sendrecv_xen_client_packets(xend_t)
 corenet_tcp_connect_xen_port(xend_t)
-
+corenet_sendrecv_xserver_client_packets(xend_t)
+corenet_sendrecv_xen_server_packets(xend_t)
+corenet_sendrecv_xen_client_packets(xend_t)
+corenet_sendrecv_soundd_server_packets(xend_t)
 corenet_rw_tun_tap_dev(xend_t)
 
-dev_getattr_all_chr_files(xend_t)
 dev_read_urand(xend_t)
+# run lsscsi
+dev_getattr_all_chr_files(xend_t)
 dev_filetrans_xen(xend_t)
 dev_rw_sysfs(xend_t)
 dev_rw_xen(xend_t)
 
 domain_dontaudit_read_all_domains_state(xend_t)
-domain_dontaudit_ptrace_all_domains(xend_t)
 
-files_read_etc_files(xend_t)
 files_read_kernel_symbol_table(xend_t)
 files_read_kernel_img(xend_t)
 files_manage_etc_runtime_files(xend_t)
 files_etc_filetrans_etc_runtime(xend_t, file)
-files_read_usr_files(xend_t)
 files_read_default_symlinks(xend_t)
-files_search_mnt(xend_t)
 
-fs_getattr_all_fs(xend_t)
-fs_list_auto_mountpoints(xend_t)
-fs_read_dos_files(xend_t)
 fs_read_removable_blk_files(xend_t)
-fs_manage_xenfs_dirs(xend_t)
-fs_manage_xenfs_files(xend_t)
 
 storage_read_scsi_generic(xend_t)
 
@@ -295,7 +325,8 @@ locallogin_dontaudit_use_fds(xend_t)
 
 logging_send_syslog_msg(xend_t)
 
-miscfiles_read_localization(xend_t)
+auth_read_passwd(xend_t)
+
 miscfiles_read_hwdata(xend_t)
 
 sysnet_domtrans_dhcpc(xend_t)
@@ -308,23 +339,7 @@ sysnet_rw_dhcp_config(xend_t)
 
 userdom_dontaudit_search_user_home_dirs(xend_t)
 
-tunable_policy(`xen_use_fusefs',`
-	fs_manage_fusefs_dirs(xend_t)
-	fs_manage_fusefs_files(xend_t)
-	fs_read_fusefs_symlinks(xend_t)
-')
-
-tunable_policy(`xen_use_nfs',`
-	fs_manage_nfs_dirs(xend_t)
-	fs_manage_nfs_files(xend_t)
-	fs_read_nfs_symlinks(xend_t)
-')
-
-tunable_policy(`xen_use_samba',`
-	fs_manage_cifs_dirs(xend_t)
-	fs_manage_cifs_files(xend_t)
-	fs_read_cifs_symlinks(xend_t)
-')
+xen_stream_connect_xenstore(xend_t)
 
 optional_policy(`
 	brctl_domtrans(xend_t)
@@ -342,7 +357,7 @@ optional_policy(`
 	mount_domtrans(xend_t)
 ')
 
-optional_policy(`
+optional_policy(`	
 	netutils_domtrans(xend_t)
 ')
 
@@ -351,6 +366,7 @@ optional_policy(`
 ')
 
 optional_policy(`
+	virt_manage_default_image_type(xend_t)
 	virt_search_images(xend_t)
 	virt_read_config(xend_t)
 ')
@@ -365,13 +381,9 @@ allow xenconsoled_t self:process setrlim
 allow xenconsoled_t self:unix_stream_socket create_stream_socket_perms;
 allow xenconsoled_t self:fifo_file rw_fifo_file_perms;
 
-allow xenconsoled_t xen_devpts_t:chr_file { rw_term_perms setattr_chr_file_perms };
-
-manage_dirs_pattern(xenconsoled_t, xend_var_log_t, xend_var_log_t)
-append_files_pattern(xenconsoled_t, xend_var_log_t, xend_var_log_t)
-create_files_pattern(xenconsoled_t, xend_var_log_t, xend_var_log_t)
-setattr_files_pattern(xenconsoled_t, xend_var_log_t, xend_var_log_t)
+allow xenconsoled_t xen_devpts_t:chr_file { rw_term_perms setattr };
 
+# pid file
 manage_files_pattern(xenconsoled_t, xenconsoled_var_run_t, xenconsoled_var_run_t)
 manage_sock_files_pattern(xenconsoled_t, xenconsoled_var_run_t, xenconsoled_var_run_t)
 files_pid_filetrans(xenconsoled_t, xenconsoled_var_run_t, { file sock_file })
@@ -384,10 +396,6 @@ dev_rw_xen(xenconsoled_t)
 dev_filetrans_xen(xenconsoled_t)
 dev_rw_sysfs(xenconsoled_t)
 
-domain_dontaudit_ptrace_all_domains(xenconsoled_t)
-
-files_read_etc_files(xenconsoled_t)
-files_read_usr_files(xenconsoled_t)
 
 fs_list_tmpfs(xenconsoled_t)
 fs_manage_xenfs_dirs(xenconsoled_t)
@@ -395,15 +403,13 @@ fs_manage_xenfs_files(xenconsoled_t)
 
 term_create_pty(xenconsoled_t, xen_devpts_t)
 term_use_generic_ptys(xenconsoled_t)
-term_use_console(xenconsoled_t)
 
 init_use_fds(xenconsoled_t)
 init_use_script_ptys(xenconsoled_t)
 
-logging_search_logs(xenconsoled_t)
-
-miscfiles_read_localization(xenconsoled_t)
+auth_read_passwd(xenconsoled_t)
 
+xen_manage_log(xenconsoled_t)
 xen_stream_connect_xenstore(xenconsoled_t)
 
 optional_policy(`
@@ -416,24 +422,26 @@ optional_policy(`
 #
 
 allow xenstored_t self:capability { dac_override ipc_lock sys_resource };
-allow xenstored_t self:unix_stream_socket { accept listen };
+allow xenstored_t self:unix_stream_socket create_stream_socket_perms;
+allow xenstored_t self:unix_dgram_socket create_socket_perms;
 
 manage_files_pattern(xenstored_t, xenstored_tmp_t, xenstored_tmp_t)
 manage_dirs_pattern(xenstored_t, xenstored_tmp_t, xenstored_tmp_t)
 files_tmp_filetrans(xenstored_t, xenstored_tmp_t, { file dir })
 
+# pid file
 manage_dirs_pattern(xenstored_t, xenstored_var_run_t, xenstored_var_run_t)
 manage_files_pattern(xenstored_t, xenstored_var_run_t, xenstored_var_run_t)
 manage_sock_files_pattern(xenstored_t, xenstored_var_run_t, xenstored_var_run_t)
 files_pid_filetrans(xenstored_t, xenstored_var_run_t, { file sock_file dir })
 
+# log files
 manage_dirs_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
-append_files_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
-create_files_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
-setattr_files_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
+manage_files_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
 manage_sock_files_pattern(xenstored_t, xenstored_var_log_t, xenstored_var_log_t)
 logging_log_filetrans(xenstored_t, xenstored_var_log_t, { sock_file file dir })
 
+# var/lib files for xenstored
 manage_dirs_pattern(xenstored_t, xenstored_var_lib_t, xenstored_var_lib_t)
 manage_files_pattern(xenstored_t, xenstored_var_lib_t, xenstored_var_lib_t)
 manage_sock_files_pattern(xenstored_t, xenstored_var_lib_t, xenstored_var_lib_t)
@@ -448,157 +456,40 @@ dev_filetrans_xen(xenstored_t)
 dev_rw_xen(xenstored_t)
 dev_read_sysfs(xenstored_t)
 
-files_read_etc_files(xenstored_t)
-files_read_usr_files(xenstored_t)
+
 
 fs_search_xenfs(xenstored_t)
 fs_manage_xenfs_files(xenstored_t)
 
 term_use_generic_ptys(xenstored_t)
+term_use_console(xenconsoled_t)
 
 init_use_fds(xenstored_t)
 init_use_script_ptys(xenstored_t)
 
 logging_send_syslog_msg(xenstored_t)
 
-miscfiles_read_localization(xenstored_t)
-
 xen_append_log(xenstored_t)
 
-########################################
-#
-# xm local policy
-#
-
-allow xm_t self:capability { setpcap dac_override ipc_lock sys_nice sys_tty_config };
-allow xm_t self:process { getcap getsched setsched setcap signal };
-allow xm_t self:fifo_file rw_fifo_file_perms;
-allow xm_t self:unix_stream_socket { accept connectto listen };
-allow xm_t self:tcp_socket { accept listen };
-
-manage_files_pattern(xm_t, xend_var_lib_t, xend_var_lib_t)
-manage_fifo_files_pattern(xm_t, xend_var_lib_t, xend_var_lib_t)
-manage_sock_files_pattern(xm_t, xend_var_lib_t, xend_var_lib_t)
-
-manage_files_pattern(xm_t, xen_image_t, xen_image_t)
-manage_blk_files_pattern(xm_t, xen_image_t, xen_image_t)
-manage_lnk_files_pattern(xm_t, xen_image_t, xen_image_t)
-
-read_files_pattern(xm_t, xenstored_var_run_t, xenstored_var_run_t)
-
-xen_manage_image_dirs(xm_t)
-xen_append_log(xm_t)
-xen_domtrans(xm_t)
-xen_stream_connect(xm_t)
-xen_stream_connect_xenstore(xm_t)
-
-can_exec(xm_t, xm_exec_t)
-
-kernel_read_system_state(xm_t)
-kernel_read_network_state(xm_t)
-kernel_read_kernel_sysctls(xm_t)
-kernel_read_sysctl(xm_t)
-kernel_read_xen_state(xm_t)
-kernel_write_xen_state(xm_t)
-
-corecmd_exec_bin(xm_t)
-corecmd_exec_shell(xm_t)
-
-corenet_all_recvfrom_unlabeled(xm_t)
-corenet_all_recvfrom_netlabel(xm_t)
-corenet_tcp_sendrecv_generic_if(xm_t)
-corenet_tcp_sendrecv_generic_node(xm_t)
-
-corenet_sendrecv_soundd_client_packets(xm_t)
-corenet_tcp_connect_soundd_port(xm_t)
-corenet_tcp_sendrecv_soundd_port(xm_t)
-
-dev_read_rand(xm_t)
-dev_read_urand(xm_t)
-dev_read_sysfs(xm_t)
-
-files_read_etc_runtime_files(xm_t)
-files_read_etc_files(xm_t)
-files_read_usr_files(xm_t)
-files_search_pids(xm_t)
-files_search_var_lib(xm_t)
-files_list_mnt(xm_t)
-files_list_tmp(xm_t)
-
-fs_getattr_all_fs(xm_t)
-fs_manage_xenfs_dirs(xm_t)
-fs_manage_xenfs_files(xm_t)
-fs_search_auto_mountpoints(xm_t)
-
-storage_raw_read_fixed_disk(xm_t)
-
-term_use_all_terms(xm_t)
-
-init_stream_connect_script(xm_t)
-init_rw_script_stream_sockets(xm_t)
-init_use_fds(xm_t)
-
-logging_send_syslog_msg(xm_t)
-
-miscfiles_read_localization(xm_t)
-
-sysnet_dns_name_resolve(xm_t)
-
-tunable_policy(`xen_use_fusefs',`
-	fs_manage_fusefs_dirs(xm_t)
-	fs_manage_fusefs_files(xm_t)
-	fs_read_fusefs_symlinks(xm_t)
-')
-
-tunable_policy(`xen_use_nfs',`
-	fs_manage_nfs_dirs(xm_t)
-	fs_manage_nfs_files(xm_t)
-	fs_read_nfs_symlinks(xm_t)
-')
-
-tunable_policy(`xen_use_samba',`
-	fs_manage_cifs_dirs(xm_t)
-	fs_manage_cifs_files(xm_t)
-	fs_read_cifs_symlinks(xm_t)
-')
-
 optional_policy(`
-	cron_system_entry(xm_t, xm_exec_t)
+	virt_read_config(xenstored_t)
 ')
 
+########################################
+#
+# SSH component local policy
+#
 optional_policy(`
-	dbus_system_bus_client(xm_t)
-
-	optional_policy(`
-		hal_dbus_chat(xm_t)
+	#Should have a boolean wrapping these
+	fs_list_auto_mountpoints(xend_t)
+	files_search_mnt(xend_t)
+	fs_getattr_all_fs(xend_t)
+	fs_read_dos_files(xend_t)
+	fs_manage_xenfs_dirs(xend_t)
+	fs_manage_xenfs_files(xend_t)
+
+	tunable_policy(`xen_use_nfs',`
+		fs_manage_nfs_files(xend_t)
+		fs_read_nfs_symlinks(xend_t)
 	')
 ')
-
-optional_policy(`
-	rpm_exec(xm_t)
-')
-
-optional_policy(`
-	vhostmd_rw_tmpfs_files(xm_t)
-	vhostmd_stream_connect(xm_t)
-	vhostmd_dontaudit_rw_stream_connect(xm_t)
-')
-
-optional_policy(`
-	virt_domtrans(xm_t)
-	virt_manage_images(xm_t)
-	virt_manage_config(xm_t)
-	virt_stream_connect(xm_t)
-')
-
-optional_policy(`
-	ssh_basic_client_template(xm, xm_t, system_r)
-
-	kernel_read_xen_state(xm_ssh_t)
-	kernel_write_xen_state(xm_ssh_t)
-
-	files_search_tmp(xm_ssh_t)
-
-	fs_manage_xenfs_dirs(xm_ssh_t)
-	fs_manage_xenfs_files(xm_ssh_t)
-')
Index: serefpolicy-contrib-20140730/xfs.te
===================================================================
--- serefpolicy-contrib-20140730.orig/xfs.te
+++ serefpolicy-contrib-20140730/xfs.te
@@ -41,7 +41,6 @@ can_exec(xfs_t, xfs_exec_t)
 kernel_read_kernel_sysctls(xfs_t)
 kernel_read_system_state(xfs_t)
 
-corenet_all_recvfrom_unlabeled(xfs_t)
 corenet_all_recvfrom_netlabel(xfs_t)
 corenet_tcp_sendrecv_generic_if(xfs_t)
 corenet_tcp_sendrecv_generic_node(xfs_t)
@@ -63,7 +62,6 @@ fs_search_auto_mountpoints(xfs_t)
 domain_use_interactive_fds(xfs_t)
 
 files_read_etc_runtime_files(xfs_t)
-files_read_usr_files(xfs_t)
 
 auth_use_nsswitch(xfs_t)
 
@@ -71,7 +69,6 @@ init_script_tmp_filetrans(xfs_t, xfs_tmp
 
 logging_send_syslog_msg(xfs_t)
 
-miscfiles_read_localization(xfs_t)
 miscfiles_read_fonts(xfs_t)
 
 userdom_dontaudit_use_unpriv_user_fds(xfs_t)
Index: serefpolicy-contrib-20140730/xguest.te
===================================================================
--- serefpolicy-contrib-20140730.orig/xguest.te
+++ serefpolicy-contrib-20140730/xguest.te
@@ -6,46 +6,47 @@ policy_module(xguest, 1.2.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether xguest can
-##	mount removable media.
-##	</p>
+## <p>
+## Allow xguest users to mount removable media
+## </p>
 ## </desc>
-gen_tunable(xguest_mount_media, false)
+gen_tunable(xguest_mount_media, true)
 
 ## <desc>
-##	<p>
-##	Determine whether xguest can
-##	configure network manager.
-##	</p>
+## <p>
+## Allow xguest users to configure Network Manager and connect to apache ports
+## </p>
 ## </desc>
-gen_tunable(xguest_connect_network, false)
+gen_tunable(xguest_connect_network, true)
 
 ## <desc>
-##	<p>
-##	Determine whether xguest can
-##	use blue tooth devices.
-##	</p>
+## <p>
+## Allow xguest to use blue tooth devices
+## </p>
 ## </desc>
-gen_tunable(xguest_use_bluetooth, false)
+gen_tunable(xguest_use_bluetooth, true)
 
 role xguest_r;
 
 userdom_restricted_xwindows_user_template(xguest)
+sysnet_dns_name_resolve(xguest_t)
+
+init_dbus_chat(xguest_t)
+init_status(xguest_t)
+systemd_dontaudit_dbus_chat(xguest_t)
 
 ########################################
 #
 # Local policy
 #
 
-kernel_dontaudit_request_load_module(xguest_t)
-
 ifndef(`enable_mls',`
 	fs_exec_noxattr(xguest_t)
 
-	tunable_policy(`user_rw_noexattrfile',`
+	tunable_policy(`selinuxuser_rw_noexattrfile',`
 		fs_manage_noxattr_fs_files(xguest_t)
 		fs_manage_noxattr_fs_dirs(xguest_t)
+		# Write floppies 
 		storage_raw_read_removable_device(xguest_t)
 		storage_raw_write_removable_device(xguest_t)
 	',`
@@ -54,9 +55,22 @@ ifndef(`enable_mls',`
 ')
 
 optional_policy(`
+	# Dontaudit fusermount
+	mount_dontaudit_exec_fusermount(xguest_t)
+')
+
+kernel_dontaudit_request_load_module(xguest_t)
+kernel_read_software_raid_state(xguest_t)
+
+tunable_policy(`selinuxuser_execstack',`
+	allow xguest_t self:process execstack;
+')
+
+# Allow mounting of file systems
+optional_policy(`
 	tunable_policy(`xguest_mount_media',`
 		kernel_read_fs_sysctls(xguest_t)
-
+		kernel_request_load_module(xguest_t)
 		files_dontaudit_getattr_boot_dirs(xguest_t)
 		files_search_mnt(xguest_t)
 
@@ -65,10 +79,9 @@ optional_policy(`
 		fs_manage_noxattr_fs_dirs(xguest_t)
 		fs_getattr_noxattr_fs(xguest_t)
 		fs_read_noxattr_fs_symlinks(xguest_t)
+		fs_mount_fusefs(xguest_t)
 
 		auth_list_pam_console_data(xguest_t)
-
-		init_read_utmp(xguest_t)
 	')
 ')
 
@@ -84,12 +97,25 @@ optional_policy(`
 	')
 ')
 
+
 optional_policy(`
-	apache_role(xguest_r, xguest_t)
+    abrt_dontaudit_read_config(xguest_t)
+')
+
+optional_policy(`
+	colord_dbus_chat(xguest_t)
+')
+
+optional_policy(`
+	chrome_role(xguest_r, xguest_t)
+')
+
+optional_policy(`
+    thumb_role(xguest_r, xguest_t)
 ')
 
 optional_policy(`
-	gnomeclock_dontaudit_dbus_chat(xguest_t)
+	dbus_dontaudit_chat_system_bus(xguest_t)
 ')
 
 optional_policy(`
@@ -97,75 +123,78 @@ optional_policy(`
 ')
 
 optional_policy(`
-	java_role(xguest_r, xguest_t)
+	apache_role(xguest_r, xguest_t)
 ')
 
 optional_policy(`
-	mozilla_role(xguest_r, xguest_t)
+	mozilla_run_plugin(xguest_t, xguest_r)
 ')
 
 optional_policy(`
-	tunable_policy(`xguest_connect_network',`
-		kernel_read_network_state(xguest_t)
+	mount_run_fusermount(xguest_t, xguest_r)
+')
+
+optional_policy(`
+	pcscd_read_pid_files(xguest_t)
+	pcscd_stream_connect(xguest_t)
+')
+
+optional_policy(`
+	rhsmcertd_dontaudit_dbus_chat(xguest_t)
+')
 
+optional_policy(`
+	tunable_policy(`xguest_connect_network',`
 		networkmanager_dbus_chat(xguest_t)
 		networkmanager_read_lib_files(xguest_t)
+	')
+')
 
-		corenet_all_recvfrom_unlabeled(xguest_t)
-		corenet_all_recvfrom_netlabel(xguest_t)
+optional_policy(`
+	tunable_policy(`xguest_connect_network',`
+		kernel_read_network_state(xguest_t)
+
+		corenet_tcp_connect_pulseaudio_port(xguest_t)
 		corenet_tcp_sendrecv_generic_if(xguest_t)
 		corenet_raw_sendrecv_generic_if(xguest_t)
 		corenet_tcp_sendrecv_generic_node(xguest_t)
 		corenet_raw_sendrecv_generic_node(xguest_t)
-
-		corenet_sendrecv_pulseaudio_client_packets(xguest_t)
-		corenet_tcp_connect_pulseaudio_port(xguest_t)
-		corenet_tcp_sendrecv_pulseaudio_port(xguest_t)
-
-		corenet_sendrecv_http_client_packets(xguest_t)
-		corenet_tcp_connect_http_port(xguest_t)
+		corenet_tcp_connect_commplex_link_port(xguest_t)
 		corenet_tcp_sendrecv_http_port(xguest_t)
-
-		corenet_sendrecv_http_cache_client_packets(xguest_t)
-		corenet_tcp_connect_http_cache_port(xguest_t)
 		corenet_tcp_sendrecv_http_cache_port(xguest_t)
-
-		corenet_sendrecv_squid_client_packets(xguest_t)
-		corenet_tcp_connect_squid_port(xguest_t)
 		corenet_tcp_sendrecv_squid_port(xguest_t)
-
-		corenet_sendrecv_ftp_client_packets(xguest_t)
-		corenet_tcp_connect_ftp_port(xguest_t)
 		corenet_tcp_sendrecv_ftp_port(xguest_t)
-
-		corenet_sendrecv_ipp_client_packets(xguest_t)
-		corenet_tcp_connect_ipp_port(xguest_t)
 		corenet_tcp_sendrecv_ipp_port(xguest_t)
-
-		corenet_sendrecv_generic_client_packets(xguest_t)
+		corenet_tcp_connect_http_port(xguest_t)
+		corenet_tcp_connect_http_cache_port(xguest_t)
+		corenet_tcp_connect_squid_port(xguest_t)
+		corenet_tcp_connect_flash_port(xguest_t)
+		corenet_tcp_connect_ftp_port(xguest_t)
+		corenet_tcp_connect_ipp_port(xguest_t)
 		corenet_tcp_connect_generic_port(xguest_t)
-		corenet_tcp_sendrecv_generic_port(xguest_t)
-
-		corenet_sendrecv_soundd_client_packets(xguest_t)
 		corenet_tcp_connect_soundd_port(xguest_t)
-		corenet_tcp_sendrecv_soundd_port(xguest_t)
-
-		corenet_sendrecv_speech_client_packets(xguest_t)
-		corenet_tcp_connect_speech_port(xguest_t)
-		corenet_tcp_sendrecv_speech_port(xguest_t)
-
-		corenet_sendrecv_transproxy_client_packets(xguest_t)
-		corenet_tcp_connect_transproxy_port(xguest_t)
-		corenet_tcp_sendrecv_transproxy_port(xguest_t)
-
+		corenet_sendrecv_http_client_packets(xguest_t)
+		corenet_sendrecv_http_cache_client_packets(xguest_t)
+		corenet_sendrecv_squid_client_packets(xguest_t)
+		corenet_sendrecv_ftp_client_packets(xguest_t)
+		corenet_sendrecv_ipp_client_packets(xguest_t)
+		corenet_sendrecv_generic_client_packets(xguest_t)
+		# Should not need other ports
 		corenet_dontaudit_tcp_sendrecv_generic_port(xguest_t)
 		corenet_dontaudit_tcp_bind_generic_port(xguest_t)
+		corenet_tcp_connect_speech_port(xguest_t)
+		corenet_tcp_sendrecv_transproxy_port(xguest_t)
+		corenet_tcp_connect_transproxy_port(xguest_t)
 	')
 ')
 
 optional_policy(`
-	pcscd_read_pid_files(xguest_t)
-	pcscd_stream_connect(xguest_t)
+	gen_require(`
+		type mozilla_t;
+	')
+
+	allow xguest_t mozilla_t:process transition;
+	role xguest_r types mozilla_t;
 ')
 
-#gen_user(xguest_u,, xguest_r, s0, s0)
+gen_user(xguest_u, user, xguest_r, s0, s0)
Index: serefpolicy-contrib-20140730/xprint.te
===================================================================
--- serefpolicy-contrib-20140730.orig/xprint.te
+++ serefpolicy-contrib-20140730/xprint.te
@@ -32,7 +32,6 @@ kernel_read_kernel_sysctls(xprint_t)
 corecmd_exec_bin(xprint_t)
 corecmd_exec_shell(xprint_t)
 
-corenet_all_recvfrom_unlabeled(xprint_t)
 corenet_all_recvfrom_netlabel(xprint_t)
 corenet_tcp_sendrecv_generic_if(xprint_t)
 corenet_udp_sendrecv_generic_if(xprint_t)
@@ -46,9 +45,7 @@ dev_read_urand(xprint_t)
 
 domain_use_interactive_fds(xprint_t)
 
-files_read_etc_files(xprint_t)
 files_read_etc_runtime_files(xprint_t)
-files_read_usr_files(xprint_t)
 files_search_var_lib(xprint_t)
 files_search_tmp(xprint_t)
 
@@ -58,7 +55,6 @@ fs_search_auto_mountpoints(xprint_t)
 logging_send_syslog_msg(xprint_t)
 
 miscfiles_read_fonts(xprint_t)
-miscfiles_read_localization(xprint_t)
 
 sysnet_read_config(xprint_t)
 
Index: serefpolicy-contrib-20140730/xscreensaver.te
===================================================================
--- serefpolicy-contrib-20140730.orig/xscreensaver.te
+++ serefpolicy-contrib-20140730/xscreensaver.te
@@ -25,7 +25,6 @@ allow xscreensaver_t self:fifo_file rw_f
 
 kernel_read_system_state(xscreensaver_t)
 
-files_read_usr_files(xscreensaver_t)
 
 auth_use_nsswitch(xscreensaver_t)
 auth_domtrans_chk_passwd(xscreensaver_t)
@@ -35,9 +34,8 @@ init_read_utmp(xscreensaver_t)
 logging_send_audit_msgs(xscreensaver_t)
 logging_send_syslog_msg(xscreensaver_t)
 
-miscfiles_read_localization(xscreensaver_t)
-
-userdom_use_user_terminals(xscreensaver_t)
+userdom_use_inherited_user_ptys(xscreensaver_t)
+#access to .icons and ~/.xscreensaver
 userdom_read_user_home_content_files(xscreensaver_t)
 
 xserver_user_x_domain_template(xscreensaver, xscreensaver_t, xscreensaver_tmpfs_t)
Index: serefpolicy-contrib-20140730/yam.te
===================================================================
--- serefpolicy-contrib-20140730.orig/yam.te
+++ serefpolicy-contrib-20140730/yam.te
@@ -73,11 +73,11 @@ auth_use_nsswitch(yam_t)
 
 logging_send_syslog_msg(yam_t)
 
-miscfiles_read_localization(yam_t)
-
 seutil_read_config(yam_t)
 
-userdom_use_user_terminals(yam_t)
+sysnet_read_config(yam_t)
+
+userdom_use_inherited_user_terminals(yam_t)
 userdom_use_unpriv_users_fds(yam_t)
 userdom_search_user_home_dirs(yam_t)
 
Index: serefpolicy-contrib-20140730/zabbix.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/zabbix.fc
+++ serefpolicy-contrib-20140730/zabbix.fc
@@ -4,12 +4,17 @@
 /usr/bin/zabbix_server	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
 /usr/bin/zabbix_agentd	--	gen_context(system_u:object_r:zabbix_agent_exec_t,s0)
 
-/usr/sbin/zabbix_server	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
 /usr/sbin/zabbix_agentd	--	gen_context(system_u:object_r:zabbix_agent_exec_t,s0)
+/usr/sbin/zabbix_server	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
 /usr/sbin/zabbix_server_mysql	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
 /usr/sbin/zabbix_server_pgsql	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
 /usr/sbin/zabbix_server_sqlite3	--	gen_context(system_u:object_r:zabbix_exec_t,s0)
+/usr/sbin/zabbix_proxy	        --	gen_context(system_u:object_r:zabbix_exec_t,s0)
+/usr/sbin/zabbix_proxy_mysql   --  gen_context(system_u:object_r:zabbix_exec_t,s0)
+/usr/sbin/zabbix_proxy_pgsql   --  gen_context(system_u:object_r:zabbix_exec_t,s0)
+/usr/sbin/zabbix_proxy_sqlite3 --  gen_context(system_u:object_r:zabbix_exec_t,s0)
 
-/var/log/zabbix(/.*)?	gen_context(system_u:object_r:zabbix_log_t,s0)
+/var/lib/zabbixsrv(/.*)?	gen_context(system_u:object_r:zabbix_var_lib_t,s0)
+/var/log/zabbix.*	gen_context(system_u:object_r:zabbix_log_t,s0)
 
 /var/run/zabbix(/.*)?	gen_context(system_u:object_r:zabbix_var_run_t,s0)
